/* Hamming-Code-Routinen */

void create_hamming(char *tab)
{
	int  i,b0,b1,b2,b3,b4,b5,b6,b7,A,B,C,D;
	
	for(i=0;i<256;i++)
	{
		b0 = i&1;
		b1 = (i&2)?1:0;
		b2 = (i&4)?1:0;
		b3 = (i&8)?1:0;
		b4 = (i&16)?1:0;
		b5 = (i&32)?1:0;
		b6 = (i&64)?1:0;
		b7 = (i&128)?1:0;
		
		A = b0^b1^b5^b7;
		B = b1^b2^b3^b7;
		C = b1^b3^b4^b5;
		D = b0^b1^b2^b3^b4^b5^b6^b7;
		
		/* Fehler in der Codierung */
		if(!D)
		{
			if( (!A)&&(!B)&&(C) )
				b7=!b7;
			if( (A)&&(B)&&(C) )
				b6=!b6;
			if( (!A)&&(B)&&(!C) )
				b5=!b5;
			if( (A)&&(B)&&(!C) )
				b4=!b4;
			if( (!A)&&(!B)&&(!C) )
				b3=!b3;
			if( (!A)&&(!B)&&(C) )
				b2=!b2;
			if( (A)&&(!B)&&(!C) )
				b1=!b1;
			if( (A)&&(B)&&(C) )
				b0=!b0;
		}
		
		if (((!A)||(!B)||(!C))&&D)
			tab[i]=-1;
		else
		  tab[i]=b1+(b3<<1)+(b5<<2)+(b7<<3);
	}
}
