/******************************************************************/
/*                                                                */
/* Tills Videotext-Decoder 								(c) 1993 Till Harbaum		*/
/*                                                         TAB: 2 */
/******************************************************************/

#define MOUSE_ON()	graf_mouse(M_ON,NULL)
#define MOUSE_OFF()	graf_mouse(M_OFF,NULL)
#define VIDEOTEXT   " Videotext-Dekoder V1.44 "

#include <aes.h>
#include <vdi.h>
#include <tos.h>
#include <stdio.h>
#include <stdlib.h>
#include <string.h>
#include <ext.h>
#include <ctype.h>
#include "videotxt.h"
#include "vid_icon.h"
#include "rtc.h"

/* Ressource reinholen */
#define  HEADLINE 17
#define  BYTE 	char
#define  WORD		int
#define  LONG		long

#define min(a, b)             ((a) < (b) ? (a) : (b))
#define max(a, b)             ((a) > (b) ? (a) : (b))
#define correct_hamming(a)    (ham_tab[a])

#define TOP_CTRL 20
#define TOP_TIME 10	 /* 20 Sek (TIME*2) */

extern int _app;
int    whandle,col_or,adips_da=FALSE;
int		 page=0x100;		/* erstmal Seite 100 */
char   hex[]="0123456789ABCDEF";

int    gl_wchar,gl_hchar,gl_wbox,gl_hbox;
int    phys_handle,handle,planes;
int    max_x,max_y,x_col,quali;
int    appl_id,menu_id,rtc_da;
int 	 icons[]={0,1,10,2,6,7,8,3,12,13,-1},i;
char   ham_tab[256];

void open_window( void );
void mouse_on( void );
void mouse_off( void );
void redraw_window( int all );
int  handle_message( int pipe[8] );
void event_loop( void );
void draw_icon(int x, int y, int num);
void draw_iconline(int x, int y);

unsigned char hilfe_seite[]=
		"                                        " /* 1 */
		"                                        "
		"\015\003 VIDEOTXT -" VIDEOTEXT "  "
		"                                        "
		"                                        "
		"  \035\001                                  \034 "
    "  \035\001    (c) 1993-96 Till Harbaum      \034 "
    "  \035\001  Hugo-Luther-Str. 18, 38118 BS   \034 "
		"  \035\001   e-mail: T.Harbaum@tu-bs.de     \034 "
		"  \035\001                                  \034 "
		"                                        "
		"\005  Tastenbelegung:                      "
		"\006  0-9a-f\007 Auswahl einer Seite          "
		"\006  +     \007 folgende Seite einlesen      "
		"\006  -     \007 vorhergehende Seite einlesen "
		"\006  H     \007 Seite 100 einlesen           "
		"\006  *     \007 verdeckten Text anzeigen     "
    "\006  S     \007 aktuelle Seite speichern     "
		"\006  P     \007 aktuelle Seite drucken       "
		"\006  N     \007 aktuelle Seite fixieren      "
		"\006  T     \007 TOP-Text anzeigen            "
		"\006  I     \007 Status-Infos anzeigen        "
	  "\006  Q     \007 Programm beenden             "
		"\006  HELP  \007 diese Hilfeseite anzeigen    " ;

unsigned int  akt_key=0,num;
char filename[18];
int  searching=FALSE,help=FALSE,top_da=FALSE,status,top_sub=TOP_CTRL;
char string[200];
char *gut_schlecht[]={"schlecht","gut"},*video_mode[]={"PAL","NTSC"};
extern 	unsigned 	char 	i2cd[];
extern	unsigned	char	seite[];
extern	int	hidden;
extern  int blink_list_hint[],blink_list_vor[],blink_anz;

void main( void )
{
   int  i,a,b;
   int  work_in[11];
   int  work_out[57];

   create_hamming(ham_tab);
   if(init_rtc()!=-1)
  	 rtc_da=TRUE;
   else
     rtc_da=FALSE;

   appl_id = appl_init( );
   if ( appl_id != -1 )
   {
      for ( i = 0; i < 10; i++ )
         work_in[i]  = 1;
      work_in[10] = 2;
      phys_handle = graf_handle( &gl_wchar, &gl_hchar, &gl_wbox, &gl_hbox );
      handle = phys_handle;
      v_opnvwk( work_in, &handle, work_out );
      if ( handle != 0 )
      {
         max_x = work_out[0];
         max_y = work_out[1];
         if((x_col = work_out[13])<7)
         	 col_or=7;
         else
         	 col_or=0;
         
		 		 vq_extnd(handle,1,work_out);
         planes = work_out[4];

				 a=test_i2c(CCTWrite);
				 
				 /* bei Accessory nicht nachfragen */
				 if((a)&&(_app))
				 {
				 	 do
				 	 {
						 if(a==1)
					 	 	 b=form_alert(1,"[1][ I2C-Bus Fehler: | Adapter nicht vorhanden. ][ Nochmal | Ende ]");
				 	   else
				 	 	   b=form_alert(1,"[1][ I2C-Bus Fehler: | CCT antwortet nicht. ][ Nochmal | Ende ]");

             if(b==1)
					     a=test_i2c(CCTWrite);
				 	 }
				 	 while((b==1)&&(a));
				 }

				 if((!a)&&((max_x<500)||(max_y<350)))
				 {
				   form_alert(1,"[1][ VIDEOTXT bentigt | mindestens 500 x 350 | Punkte. ][ OK ]");
				   a=FALSE;
				 }

				 if(!a)
				 {
				 	 init_videotext();
         
           if ( !_app )
              menu_id = menu_register( appl_id, "  Videotext" );
           else
           {
              graf_mouse( 0, (void*)0 );
              open_window( );
           }
           event_loop( );
         }
         
         if(!_app)		/* Accessory darf nicht beendet werden */
				   event_loop();

         v_clsvwk( handle );
      }
      appl_exit( );
   }
   exit( 0 );
}

void draw_page_num(int num, int wx, int wy)
{
	int i;
#ifdef DEMO
	return;
#endif

	set_back(0);
	
	if(check_page_top(num))
	{
		for(i=0;i<3;i++)
			draw_chr(wx+12*i,wy+HEADLINE,hex[ (num>>(4*(2-i))) &0xf ],1|col_or,FALSE);
	}
	else
	{
		for(i=0;i<3;i++)
			draw_chr(wx+12*i,wy+HEADLINE,hex[ (num>>(4*(2-i))) &0xf ],5|col_or,FALSE);
	}
}

extern unsigned	char seite[];
void open_window( void )
{
   int 	ix,iy,iw,ih,pxy[8],i,wx,wy,ww,wh;

   if ( whandle <= 0 )
   {
   		wind_get(0,WF_WORKXYWH,&wx,&wy,&ww,&wh);
   
      whandle = wind_create(NAME|CLOSER|MOVER,wx,wy,ww,wh);
      if ( whandle <= 0 )
         return;

      wind_set( whandle, WF_NAME, VIDEOTEXT );
			i=test_signal();
			if(i!=0)
				quali=i;

		  wind_calc(WC_BORDER,NAME|CLOSER|MOVER,(ww/2)-240,(wh/2)-(144+HEADLINE/2+7),480,288+HEADLINE+14,&ix,&iy,&iw,&ih);
			ix+=wx; iy+=wy;
      wind_open( whandle,ix,iy,iw,ih);

			MOUSE_OFF();
			wind_get(whandle,WF_WORKXYWH,&ix,&iy,&iw,&ih);
			pxy[0]=ix; pxy[1]=iy; pxy[2]=ix+iw+1; pxy[3]=iy+ih+1;
			vsf_color(handle,1);
			vsf_interior(handle,FIS_SOLID);
			vr_recfl(handle,pxy);

	    for(i=0;i<960;i++)
	    	seite[i]=hilfe_seite[i];

#ifdef DEMO
  {
  	FILE *f;
  	f=fopen("c:\\projekte\\videotxt\\examples\\ch-txt_2.vtx","rb");
	  if(f!=NULL) {
			fread(seite,12,1,f);
			fread(seite,960,1,f);
			fclose(f);  

			for(i=0;i<960;i++)
				seite[i]=seite[i]&0x7f;

			seite[967]=8;
		}
  }
#endif

			page=0x100;
			get_page(page);
			draw_page_num(page,ix,iy);
			MOUSE_ON();
   }
   else
      wind_set( whandle, WF_TOP );
}

int rc_intersect( GRECT *r1, GRECT *r2 )
{
   int x, y, w, h;

   x = max( r2->g_x, r1->g_x );
   y = max( r2->g_y, r1->g_y );
   w = min( r2->g_x + r2->g_w, r1->g_x + r1->g_w );
   h = min( r2->g_y + r2->g_h, r1->g_y + r1->g_h );

   r2->g_x = x;
   r2->g_y = y;
   r2->g_w = w - x;
   r2->g_h = h - y;

   return ( ((w > x) && (h > y) ) );
}

void mouse_on( void )
{
   graf_mouse( M_ON, (void *)0 );
}

void mouse_off( void )
{
   graf_mouse( M_OFF, (void *)0 );
}

void redraw_window( int all )
{
   GRECT     box,work;
   int       clip[4],pxy[4],i;

   /* Fenster offen ? */
   if( whandle <= 0 )
      return;

   mouse_off( );

   vsf_color( handle, 0 );                       /* set white fill   */
   vswr_mode( handle, 1 );                       /* set replace mode */

   wind_get( whandle, WF_WORKXYWH, &work.g_x, &work.g_y, &work.g_w, &work.g_h );
   wind_get( whandle, WF_FIRSTXYWH, &box.g_x, &box.g_y, &box.g_w, &box.g_h );
   work.g_w = min( work.g_w, max_x - work.g_x + 1 );
   work.g_h = min( work.g_h, max_y - work.g_y + 1 );

   while ( box.g_w > 0 && box.g_h > 0 )
   {
     if( rc_intersect( &work, &box ) )
     {
        clip[0] = box.g_x;
        clip[1] = box.g_y;
        clip[2] = box.g_x + box.g_w - 1;
        clip[3] = box.g_y + box.g_h - 1;

        vs_clip( handle, 1, clip );
				wind_get(whandle,WF_WORKXYWH, &box.g_x, &box.g_y, &box.g_w, &box.g_h );

				if(all)
				{
					draw_iconline(box.g_x,box.g_y);

					set_back(0);
#ifndef DEMO
					for(i=0;i<3;i++)
						draw_chr(box.g_x+12*i,box.g_y+HEADLINE,hex[(page>>(4*(2-i))) &0xf ],2|col_or,FALSE);
#endif
				}
				draw_videotext(box.g_x,box.g_y+HEADLINE);

				vsf_color(handle,1);
				vsf_interior(handle,FIS_SOLID);
				pxy[0]=box.g_x; 			  pxy[1]=box.g_y+HEADLINE+12*24;
				pxy[2]=box.g_x+box.g_w; pxy[3]=box.g_y+HEADLINE+12*24+2;
				vr_recfl(handle,pxy);

				top_zeile(box.g_x,box.g_y,page);
     }
     wind_get( whandle, WF_NEXTXYWH, &box.g_x, &box.g_y, &box.g_w, &box.g_h );
  }
  mouse_on( );
}

int handle_message( int pipe[8] )
{
   switch ( pipe[0] )
   {
     case WM_REDRAW:
         redraw_window( TRUE );
      break;

      case WM_TOPPED:
         wind_set( whandle, WF_TOP );
      break;

      case WM_CLOSED:
         if ( pipe[3] == whandle )
         {
            wind_close( whandle );
            wind_delete( whandle );
            whandle = 0;
         }
         if ( _app )
            return ( 1 );
      break;

      case WM_MOVED:
      case WM_SIZED:
         if ( pipe[3] == whandle )
            wind_set( whandle, WF_CURRXYWH,  pipe[4], pipe[5], pipe[6], pipe[7] );
     break;

      case AC_OPEN:
         if ( pipe[4] == menu_id )
            open_window( );
      break;

      case AC_CLOSE:
         if ( pipe[3] == menu_id )
            whandle = 0;
      break;
   }
   return ( 0 );
}

void update_rtc(int wx, int wy)
{
	 int  jahr,monat,tag,stunde,minute,sekunde,dum;
	 char zeit_string[32];

	 get_time(&jahr,&monat,&tag,&stunde,&minute,&sekunde);
	 sprintf(zeit_string,"RTC: %02d.%02d.%04d %02d:%02d:%02d",tag,monat,jahr,stunde,minute,sekunde);

	 vst_color(handle,1);
	 vst_point (handle, 8, &dum,&dum,&dum,&dum);
	 vswr_mode(handle,MD_REPLACE);
	 v_gtext(handle,wx+333,wy+6,zeit_string);
}

unsigned char head_buffer[32];
unsigned char head_color[32];
void redraw_headline(int wx, int wy, unsigned char *data)
{
  int i;
  unsigned char color=7;

  mouse_off();
	set_back(0);

	for(i=0;i<32;i++)
	{
		if(data[i]<32)
		{
			if(data[i]<8)
			  color=data[i];
		  data[i]=32;
		}

		if((data[i]!=head_buffer[i])||(color!=head_color[i]))
		{
			draw_chr(wx+12*(8+i),wy+HEADLINE,data[i]&0x7f,color|col_or,FALSE);
			head_buffer[i]=data[i];
			head_color[i]=color;
		}
	}
	mouse_on();
}

void event_loop( void )
{
   int 	kstate,key,clicks,event,state,buff,grafik,off;
   int 	pipe[8],x,y,wx,wy,ww,wh,pxy[10],dum,top_sec,top,fixed=FALSE;
   int 	quit,count=0,colarr[3],cnt=0,but,rtc_sec=0;
   char	path[128];
   unsigned char line_buffer2[40];
   unsigned int i,j;
   static int blink_flag=TRUE;
   FILE *file;

	 for(i=0;i<32;i++)
	   head_color[i]=head_buffer[i]=0;
	   
   quit = 0;   /* clicks, mask, state -> r oder l :clicks+256 */
			   /* 0x100,0x3,0x00 */
   do
   {
	    event = evnt_multi(MU_MESAG|MU_KEYBD|MU_TIMER|MU_BUTTON,
	    										0,1,1,0,0,0,0,0,0,0,0,0,0,pipe,
    	                   	100,0,&x,&y,&state,&kstate,&key,&clicks);

			wind_get(whandle,WF_TOP,&top,&dum,&dum,&dum);
			wind_get(whandle,WF_WORKXYWH,&wx,&wy,&ww,&wh);
      wind_update( BEG_UPDATE );

			if (( event & MU_TIMER )&&(whandle==top)&&(whandle>0))
			{
				rtc_sec++;
				if(rtc_sec>10)
				{
				  rtc_sec=0;
				  if(rtc_da)
				    update_rtc(wx,wy);
				}
			
				if(!top_sub--)
				{
					top_sub=TOP_CTRL;		/* RELOAD */
			
					if(check_top(wx,wy,page))
					{
						top_sec=TOP_TIME;		/* mind. alle 10sec TOP-Kennung */
				
						if(!top_da)
						{
							top_da=TRUE;
							draw_iconline(wx,wy);
						}
					}
			
					if(!--top_sec)
					{
						top_sec=TOP_TIME;
						
						if(top_da)
						{	
							adips_da=FALSE;
							top_da=FALSE;
							mouse_off();
							draw_iconline(wx,wy);
							top_zeile(wx,wy,page);
							mouse_on();
						}
					}
				}
			
				if((searching)&&(!fixed))
				{
					if(!arrived(0))
					{
						pxy[0]=wx;			pxy[1]=wy;
						pxy[2]=wx+ww-1;	pxy[3]=wy+wh-1;
						vs_clip(handle,1,pxy);
					
						i2cd[0] = 8 ;
				 		i2cd[1] = 0 ;
				 		i2cd[2]	= 0 ;
				 		i2cd[3] = 8 ;
						sendi2c(CCTWrite, 4, i2cd);
						delay(10);
						receivei2c(CCTRead, 32, line_buffer2);
#ifndef DEMO
						if(!help)
							redraw_headline(wx,wy,line_buffer2);
#endif
					} else {
						if(akt_key==0)
						{
							mouse_off();
							set_back(0);
							for(i=0;i<3;i++)
								draw_chr(wx+12*i,wy+HEADLINE,hex[(page>>(4*(2-i))) &0xf ],2|col_or,FALSE);
							mouse_on();
						}
						delay(200);
						getpage (0, seite) ;

						/* ist es eine TOP-Text-Seite ?? */
						if((page==0x1f0)||(page==0x1f1))
						{
							for(i=40;i<960;i++)
							  seite[i]=hex[correct_hamming((unsigned)seite[i])];
						}

						/* ist es eine ADIP ?? */
						if((page==0x1f2)||(page==0x1f3))
						{
							for(i=0;i<44;i++)
								for(j=0;j<8;j++)
							  	seite[40+(20*i)+j]=hex[correct_hamming((unsigned)seite[40+(20*i)+j])];
						}
						
						redraw_window( FALSE );
						searching=FALSE;
						get_page(page);
					}
				}

				if(cnt++==5)	/* zweimal pro Sekunde */
				{
					cnt=0;
					if(x_col>=24)
					{	
						blink_flag=!blink_flag;
					 	i=0;
					 	while(i<blink_anz)
						{
							if(blink_flag)
						  	vq_color(handle,blink_list_vor[i],1,colarr);
							else
						   	vq_color(handle,blink_list_hint[i],1,colarr);

							vs_color(handle,16+i,colarr);
							i++;
					 	}
					}
				}					

				if(count++==10)	/* einmal pro Sekunde */
				{
					if((i=test_signal())!=0)
					{
						quali=i;
						draw_iconline(wx,wy);
					}
						
					count=0;
				}
			}

			/* Maus geklickt? */
			if ( event & MU_BUTTON )
			{
				x-=wx;
				y-=wy;

				if((x>=0)&&(x<480)&&(y>=0)&&(y<16))
				{
					/* Iconnummer */
					j=x/16;
					for(i=0;(icons[i]!=-1)&&(i!=j);i++);

					switch(icons[i])
					{
						case 0:  	event=MU_KEYBD;
											key=0x53;
										 	break;
						case 1:  	event=MU_KEYBD;
											key=0x2d;
										 	break;
						case 10: 	event=MU_KEYBD;
											key=0x48;
										 	break;
						case 2:  	event=MU_KEYBD;
											key=0x2b;
										 	break;
						case 6:  	event=MU_KEYBD;
											key=0x6200;
											break;
						case 7:  	event=MU_KEYBD;
											key=0x2a;
										 	break;
						case 8:  	event=MU_KEYBD;
											key=0x50;
										 	break;
						case 11:
						case 12:	event=MU_KEYBD;
											key=0x54;
											break;
						case 13:	event=MU_KEYBD;
											key=0x4e;
											break;
						case 3:
						case 4:
						case 5:		event=MU_KEYBD;
											key=0x49;
											break;
					}
					evnt_button(0,1,0,&dum,&dum,&dum,&dum);
				}
				
				y-=HEADLINE;
				
				/* Window APID-Bereich getroffen ? */
				if((x>=0)&&(x<(12*40))&&(y>=288)&&(y<302))
				{
#if 0
					printf("\033H APID getroffen: %d ",x);
#endif
					if((x>=0)&&(x<=155))
						buff=get_adip_pagenum(0);
					if((x>=156)&&(x<=323))
						buff=get_adip_pagenum(1);
					if((x>=324)&&(x<=479))
						buff=get_adip_pagenum(2);

					mouse_off();
					draw_page_num(buff,wx,wy);
					page=buff;
					get_page(page);
					mouse_on();
				}
				
				/* Window-Textbereich getroffen? */
				if((x>=0)&&(x<(12*40))&&(y>=12)&&(y<(12*24)))
				{
					x/=12;
					y/=12;

					i=x+40*y;
					
					/* Ziffer geklickt? */
					if(isdigit(seite[x+40*y]))
					{
						/* Anfang der Zahl suchen */
						while(isdigit(seite[i]))	i--;
						
						/* steht da eine dreistellige Zahl? */
						if(	(!isdigit(seite[i]))&&(isdigit(seite[i+1]))&&
								(isdigit(seite[i+2]))&&(isdigit(seite[i+3]))&&
								(!isdigit(seite[i+4])))
						{
							buff=256*(seite[i+1]-'0')+16*(seite[i+2]-'0')+seite[i+3]-'0';
							
							/* gibts die Seite auch ? */
							if((buff>0x99)&&(buff<0x900))
							{
								mouse_off();
								draw_page_num(buff,wx,wy);
								page=buff;
								get_page(page);
								mouse_on();
							}
						}		
					}
				}
			}

			if (( event & MU_KEYBD )&&( whandle==top)&&(whandle>0))
			{
				buff=page;
				
				/* HELP gedrckt */
				if(key==0x6200)
				{
					help=!help;
					redraw_window( FALSE );
				}

				/* S gedrckt */
				if(((key&0xff)==0x53)||((key&0xff)==0x73))
				{
					sprintf(filename,"%.8s.%03X",&seite[12],page);
					for(i=0;filename[i+4]!=0;i++)
						if(!isalnum(filename[i]))
							filename[i]='_';
							
					path[0]=Dgetdrv()+'A';
					path[1]=':';
					Dgetpath(&path[2],0);
					strcat(path,"\\*.*");
							
					if(Sversion()>=0x104)
						fsel_exinput(path,filename,&but,"Seite speichern");
					else
					  fsel_input(path,filename,&but);

					if(strrchr(path,'\\')!=NULL)
						*(strrchr(path,'\\')+1)='\0';
						
					strcat(path,filename);
						
					if(but==1)		/* OK ?? */
					{
						file=fopen(filename,"w");
						if(file!=NULL)
						{
							grafik=FALSE;

							for(i=0;i<960;i++)
							{
								if(seite[i]<32)
								{
									if(seite[i]<8)
  									grafik=FALSE;
  								if((seite[i]>15)&&(seite[i]<24))
  									grafik=TRUE;
  		
							  	fputc(' ',file);
								}
								else
								{
									if(!grafik)
									{
								    switch(seite[i])
    								{
    									case '@': fputc('',file);  break;
    									case '[': fputc('',file);	break;
								    	case '\\':fputc('',file);	break;
								    	case ']': fputc('',file);	break;
								    	case '{': fputc('',file);	break;
								    	case '|': fputc('',file);	break;
								    	case '}': fputc('',file);	break;
								    	case '~': fputc('',file);	break;
											default:	fputc(seite[i],file);
								    }
									}
									else
										fputc(' ',file);
								}
							
								if(((i+1)%40)==0)
									fprintf(file,"\n");
							}
							fclose(file);
						}
						else
							form_alert(1,"[1][ Konnte Datei nicht | ffnen! ][ Schade ]");
					}
				}

				/* F1-F3 gedrckt */
				if((key==0x3b00)||(key==0x3c00)||(key==0x3d00))
				{
					if(adips_da)
					{
						if(key==0x3b00)
							page=get_adip_pagenum(0);

						if(key==0x3c00)
							page=get_adip_pagenum(1);

						if(key==0x3d00)
							page=get_adip_pagenum(2);

						mouse_off();
						draw_page_num(page,wx,wy);
						mouse_on();
					}
				}

				/* P gedrckt */
				if(((key&0xff)==0x50)||((key&0xff)==0x70))
				{
					print_page();
				}
				
				/* * gedrckt */
				if((key&0xff)==0x2a)
				{
					hidden=!hidden;
					redraw_window( FALSE );
				}

				/* h gedrckt */
				if(((key&0xff)==0x48)||((key&0xff)==0x68))
				{
					page=0x100;
					mouse_off();
					draw_page_num(page,wx,wy);
					mouse_on();
				}
				
				/* i gedrckt */
				if(((key&0xff)==0x49)||((key&0xff)==0x69))
				{
					status=i2cstat();
					sprintf(string,"[1][ Bildqualitt: %s | Textqualitt: %s | %s-Modus | ROM-Version %d ][ OK ]",
					        gut_schlecht[status&1],gut_schlecht[(status>>1)&1],video_mode[(status>>7)&1],(status>>2)&0x0f);
					form_alert(1,string);
				}
			
				/* +/- gedrckt */
				if(((key&0xff)==0x2b)||((key&0xff)==0x2d))
				{
					if((key&0xff)==0x2d)	page--; else page++;

					/* beim Zhlen Hex-Zahlen und nicht vorhandene Seiten auslassen */
					while( ((page&0x0f)>9) || (((page>>4)&0x0f)>9) || (((page>>8)&0x0f)>9) || (!check_page_top(page)))
						if((key&0xff)==0x2d)	page--; else page++;
					
					if(page<0x100)					page=0x100;
					if(page>0x899)					page=0x899;

					mouse_off();
					draw_page_num(page,wx,wy);
					mouse_on();
				}
				
				/* T gedrckt */
				if(((key&0xff)==0x54)||((key&0xff)==0x74))
				{
					if(!top_da)
						form_alert(1,"[1][ Es wird momentan | kein TOP-Text | gesendet! ][ OK ]");
					else
					{
						sprintf(string,"[1][ Der Seitenzyklus enthlt  | %d Seiten. ][ Aha ]",get_page_anz());
						form_alert(1,string);
					}
				}

				/* N gedrckt */
				if(((key&0xff)==0x4e)||((key&0xff)==0x6e))
					fixed=!fixed;

				/* Q gedrckt */
				if(((key&0xff)==0x51)||((key&0xff)==0x71)) {
					if(_app) 
						quit=TRUE;
					else {
         		if ( pipe[3] == whandle ) {
         			wind_close( whandle );
         			wind_delete( whandle );
         			whandle = 0;
         		}
					}
				}

				/* Ziffer oder a-f gedrckt */
				if((((key&0xff)>=0x30)&&((key&0xff)<=0x39))||
				   (((key&0xff)>=97)  &&((key&0xff)<=102)))
				{
					if(akt_key==0)
						num=0;
				
					if((key&0xff)<97)
						off=(key&0xff)-0x30;
					else	
						off=(key&0xff)-87;
					
					num+=(off*(1<<(4*(2-akt_key))));
						
					set_back(0);
					MOUSE_OFF();
					draw_chr(wx+12*(akt_key),wy+HEADLINE,hex[off],7,FALSE);
					if(akt_key==0)
					{
						draw_chr(wx+12,wy+HEADLINE,' ',7,FALSE);
						draw_chr(wx+24,wy+HEADLINE,' ',7,FALSE);
					}
					akt_key++;
					if(akt_key==3)
					{
						if(num<0x100)		num=0x100;
						if(num>0x8ff)		num=0x8ff;

						draw_page_num(num,wx,wy);
						akt_key=0;
						page=num;
						buff=-1;
					}
					MOUSE_ON();
				}
				else
					buff=-1;
					
				if(buff!=page)
					get_page(page);
			}

      if ( event & MU_MESAG )
         quit = handle_message( pipe );

      wind_update( END_UPDATE );
   }
   while ( !quit );
}

void draw_iconline(int x, int y)
{
	int pxy[10];
	
	icons[7]=quali;
	icons[8]=(top_da)?11:12;

	for(i=0;icons[i]!=-1;i++);
	i*=16;
	
	pxy[0]=x; 		pxy[1]=pxy[3]=y+HEADLINE-1;	pxy[2]=x+480;
	if(planes<4)
		vsl_color(handle,0);
	else
		vsl_color(handle,9);
	v_pline(handle,2,pxy);

	pxy[0]=x+i;		pxy[1]=0; pxy[3]=y+HEADLINE-2;	pxy[2]=x+480;
	if(planes<4)
	{
		vsf_style(handle,4);
		vsf_interior(handle,FIS_PATTERN);
		vsf_color(handle,1);
	}
	else
	{
		vsf_interior(handle,FIS_SOLID);
		vsf_color(handle,8);
	}
	vr_recfl(handle,pxy);
	
	i=0;
	while(icons[i]!=-1)
	{
		draw_icon(i,0,icons[i]);
		i++;
	}
	if(rtc_da)
		update_rtc(x,y);
}

void draw_icon(int x, int y, int num)
{
	int 	pxy[10],wx,wy,ww,wh,color[]={1,0};
	MFDB	src,dest;
	int		buffer[128],i;

	x*=16;  y*=16;

	wind_get(whandle,WF_WORKXYWH,&wx,&wy,&ww,&wh);
	pxy[0]=0; 				pxy[1]=0;
	pxy[2]=15;   			pxy[3]=15;
	pxy[4]=wx+x;			pxy[5]=wy+y;
	pxy[6]=wx+x+15; 	pxy[7]=wy+y+15;

	if(planes<4)
	{		
		src.fd_addr=sprite_ptr[num][0];
		src.fd_wdwidth=1;
		src.fd_w=16;
		src.fd_h=16;
		src.fd_stand=1;
		src.fd_nplanes=1;
		dest.fd_addr=0l;
		vrt_cpyfm(handle,MD_REPLACE,pxy,&src,&dest,color);
	}
	else
	{
		for(i=0;i<64;i++)  buffer[i]=sprite_ptr[num][2][i];
		/* Rest lschen, nur bei 15 alle Bits fllen */
		for(i=64;i<80;i++) buffer[i]=buffer[i+16]=buffer[i+32]=buffer[i+48]=
						(sprite_ptr[num][2][i-64]&sprite_ptr[num][2][i-48]&
						 sprite_ptr[num][2][i-32]&sprite_ptr[num][2][i-16]);
	
		src.fd_addr=buffer;
		src.fd_wdwidth=1;
		src.fd_w=16;
		src.fd_h=16;
		src.fd_stand=1;
		src.fd_nplanes=planes;
		dest.fd_addr=buffer;
		dest.fd_wdwidth=1;
		dest.fd_w=16;
		dest.fd_h=16;
		dest.fd_stand=0;
		dest.fd_nplanes=planes;
		vr_trnfm(handle,&src,&dest);

		src.fd_addr=buffer;
		src.fd_wdwidth=1;
		src.fd_w=16;
		src.fd_h=16;
		src.fd_stand=0;
		src.fd_nplanes=planes;
		dest.fd_addr=0l;		
		vro_cpyfm(handle,S_ONLY,pxy,&src,&dest);	
	}
}